/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.23 by edhill, Fri Oct 24 05:52:05 2003 UTC revision 1.64 by edhill, Sun Jan 25 00:22:57 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo -n "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 72  find_possible_configs()  { Line 77  find_possible_configs()  {
77    
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
86            
87      echo "test" > test      echo "test" > test
88      ln -s ./test link      ln -s ./test link
# Line 103  find_possible_configs()  { Line 100  find_possible_configs()  {
100          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
101      fi      fi
102    
103        # makedepend is not always available
104        if test "x${MAKEDEPEND}" = x ; then
105          which makedepend >& /dev/null
106          RETVAL=$?
107          if test "x${RETVAL}" = x1 ; then
108             echo "    makedepend was not found. Using xmakedpend instead."
109             MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
110          fi
111        fi
112    
113      # look for possible fortran compilers      # look for possible fortran compilers
114      tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
115      p_FC=      p_FC=
116      for c in $tmp ; do      for c in $tmp ; do
117          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 205  get_pdepend_list()  { Line 212  get_pdepend_list()  {
212      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
213          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
214          > ./.pd_tmp          > ./.pd_tmp
215      source ./.pd_tmp      . ./.pd_tmp
216      rm -f ./.pd_tmp      rm -f ./.pd_tmp
217    
218      echo -n "PNAME = "${}      echo -n "PNAME = "${}
# Line 214  get_pdepend_list()  { Line 221  get_pdepend_list()  {
221    
222  #  Explain usage  #  Explain usage
223  usage()  {  usage()  {
224      echo  cat <<EOF
225      echo "Usage: "$0" [OPTIONS]"  
226      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
227      echo    where [OPTIONS] can be:
228      echo "    -help | --help | -h | --h"  
229      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
230      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
231      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
232      echo "    -pdepend NAME | --pdepend NAME"      -nooptfile | --nooptfile
233      echo "      -pdepend=NAME | --pdepend=NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
234      echo "    -pdefault NAME | --pdefault NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
235      echo "      -pdefault=NAME | --pdefault=NAME"            Use "NAME" as the optfile.  By default, an attempt will be
236      echo "    -make NAME | -m NAME"            made to find an appropriate "standard" optfile in the
237      echo "      --make=NAME | -m=NAME"            tools/build_options/ directory.
238      echo "    -makefile NAME | -mf NAME"  
239      echo "      --makefile=NAME | -mf=NAME"      -pdepend NAME | --pdepend NAME
240      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"        -pdepend=NAME | --pdepend=NAME
241      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            Get package dependency information from "NAME".
242      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"  
243      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"      -pdefault NAME | --pdefault NAME
244      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"        -pdefault=NAME | --pdefault=NAME
245      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"            Get the default package list from "NAME".
246      echo "    -disable NAME | --disable NAME"  
247      echo "      -disable=NAME | --disable=NAME"      -make NAME | -m NAME
248      echo "    -enable NAME | --enable NAME"        --make=NAME | -m=NAME
249      echo "      -enable=NAME | --enable=NAME"            Use "NAME" for the MAKE program. The default is "make" but
250      echo "    -standarddirs NAME | --standarddirs NAME"            many platforms, "gmake" is the preferred choice.
251      echo "      -standarddirs=NAME | --standarddirs=NAME"  
252      echo "    -noopt NAME | --noopt NAME"      -makefile NAME | -mf NAME
253      echo "      -noopt=NAME | --noopt=NAME"        --makefile=NAME | -mf=NAME
254  #    echo "    -cpp NAME | --cpp NAME"            Call the makefile "NAME".  The default is "Makefile".
255  #    echo "      -cpp=NAME | --cpp=NAME"  
256      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
257      echo "      -fc=NAME | --fc=NAME"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
258      echo "    -[no]ieee | --[no]ieee"            Specify the location of the MITgcm ROOTDIR as "NAME".
259      echo "    -[no]mpi | --[no]mpi"            By default, genamke will try to find the location by
260      echo "    -[no]jam | --[no]jam"            looking in parent directories (up to the 5th parent).
261      echo  
262      echo "  and NAME is a string such as:"      -mods NAME | --mods NAME | -mo NAME | --mo NAME
263      echo        -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
264      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"            Here, "NAME" specifies a list of directories that are
265      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"            used for additional source code.  Files found in the
266      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"            "mods list" are given preference over files of the same
267      echo            name found elsewhere.
268      echo "  which, depending upon your shell, may need to be single-quoted"  
269      echo "  if it contains spaces, dashes, or other special characters."      -disable NAME | --disable NAME
270          -disable=NAME | --disable=NAME
271              Here "NAME" specifies a list of packages that we don't
272              want to use.  If this violates package dependencies,
273              genamke will exit with an error message.
274    
275        -enable NAME | --enable NAME
276          -enable=NAME | --enable=NAME
277              Here "NAME" specifies a list of packages that we wish
278              to specifically enable.  If this violates package
279              dependencies, genamke will exit with an error message.
280    
281        -standarddirs NAME | --standarddirs NAME
282          -standarddirs=NAME | --standarddirs=NAME
283              Here, "NAME" specifies a list of directories to be
284              used as the "standard" code.
285    
286        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
287          -fc=NAME | --fc=NAME
288              Use "NAME" as the fortran compiler.  By default, genmake
289              will search for a working compiler by trying a list of
290              "usual suspects" such as g77, f77, etc.
291    
292        -[no]ieee | --[no]ieee
293              Do or don't use IEEE numerics.  Note that this option
294              *only* works if it is supported by the OPTFILE that
295              is being used.
296    
297      While it is most often a single word, the "NAME" variables specified
298      above can in many cases be a space-delimited string such as:
299    
300        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
301        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
302        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
303    
304      which, depending upon your shell, may need to be single-quoted.
305    
306      For more detailed genmake documentation, please see:
307    
308        http://mitgcm.org/devel_HOWTO/
309    
310    EOF
311    
312      exit 1      exit 1
313  }  }
314    
315  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
316  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
317  #eh3 set CPP        = ( '/lib/cpp -P' )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
318  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      
319  #eh3 set KPP        = (  )      cat > genmake_test.c <<EOF
320  #eh3 set FC         = ( 'f77' )  void tcall( char * string ) { tsub( string ); }
321  #eh3 set LINK       = $FC  EOF
322  #eh3 set MAKEDEPEND = ( 'makedepend' )      $MAKE genmake_test.o >> genmake_warnings 2>&1
323  #eh3 set INCLUDES   = ( -I. )      RETVAL=$?
324  #eh3 set FFLAGS     = (  )      if test "x$RETVAL" != x0 ; then
325  #eh3 set FOPTIM     = (  )          FC_NAMEMANGLE=$default_nm
326  #eh3 set CFLAGS     = (  )          cat <<EOF>> genmake_errors
327  #eh3 set KFLAGS1    = (  )  
328  #eh3 set KFLAGS2    = (  )  WARNING: C test compile fails
329  #eh3 set LIBS       = (  )  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
330  #eh3 set KPPFILES   = (  )  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
331  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )  EOF
332  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          return 1
333        fi
334        c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
335        RETVAL=$?
336        if test "x$RETVAL" != x0 ; then
337            FC_NAMEMANGLE=$default_nm
338            cat <<EOF>> genmake_warnings
339    
340    WARNING: The "nm" command failed.
341    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
342    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
343    EOF
344            return 1
345        fi
346        cat > genmake_tcomp.f <<EOF
347          subroutine tcall( string )
348          character*(*) string
349          call tsub( string )
350          end
351    EOF
352        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
353        RETVAL=$?
354        if test "x$RETVAL" != x0 ; then
355            FC_NAMEMANGLE=$default_nm
356            cat <<EOF>> genmake_warnings
357    
358    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
359    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
360    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
361    EOF
362            return 1
363        fi
364        f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
365        RETVAL=$?
366        if test "x$RETVAL" != x0 ; then
367            FC_NAMEMANGLE=$default_nm
368            cat <<EOF>> genmake_warnings
369    
370    WARNING: The "nm" command failed.
371    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
372    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
373    EOF
374            return 1
375        fi
376    
377        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
378        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
379        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
380        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
381    
382        nmangle="X"
383        if test "x$c_a" != "x$f_a" ; then
384            comm="echo x$f_a | sed -e 's|x$c_a||'"
385            a=`eval $comm`
386            nmangle="$a ## $nmangle"
387        fi
388        if test "x$c_b" != "x$f_b" ; then
389            comm="echo x$f_b | sed -e 's|x$c_b||'"
390            b=`eval $comm`
391            nmangle="$nmangle ## $b"
392        fi
393    
394        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
395    
396        #  cleanup the testing files
397        rm -f genmake_tcomp.* genmake_test.*
398    }
399    
400    
401    check_HAVE_CLOC()  {
402        get_fortran_c_namemangling
403        cat <<EOF > genmake_tc_1.c
404    $FC_NAMEMANGLE
405    #include <stdio.h>
406    #include <stdlib.h>
407    #include <unistd.h>
408    #include <assert.h>
409    #include <sys/time.h>
410    void FC_NAMEMANGLE(cloc) ( double *curtim )
411    {
412     struct timeval tv1;
413     gettimeofday(&tv1 , (void *)NULL );
414     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
415     *curtim = *curtim/1.E6;
416    }
417    EOF
418        make genmake_tc_1.o >> genmake_tc.log 2>&1
419        RET_C=$?
420        cat <<EOF > genmake_tc_2.f
421          program hello
422          Real*8 wtime
423          external cloc
424          call cloc(wtime)
425          print *," HELLO WORLD", wtime
426          end program hello
427    EOF
428        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
429        RET_F=$?
430        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
431        RETVAL=$?
432        if test "x$RETVAL" = x0 ; then
433            HAVE_CLOC=t
434            DEFINES="$DEFINES -DHAVE_CLOC"
435        fi
436        rm -f genmake_tc*
437    }
438    
439    
440    check_netcdf_libs()  {
441        cat <<EOF > genmake_tnc.F
442          program fgennc
443    #include "netcdf.inc"
444          integer iret, ncid, xid
445          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
446          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
447          iret = nf_def_dim(ncid, 'X', 11, xid)
448          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
449          iret = nf_close(ncid)
450          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
451          end
452    EOF
453        $CPP genmake_tnc.F > genmake_tnc.f  \
454            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
455        RET_COMPILE=$?
456        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
457        RETVAL=$?
458        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
459            HAVE_NETCDF=t
460        else
461            cat genmake_tnc.log >> genmake_warnings
462        fi
463        rm -f genmake_tnc*
464    }
465    
466    
467  #  Set defaults here  #  Set defaults here
468  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 290  LN= Line 472  LN=
472  S64=  S64=
473  KPP=  KPP=
474  FC=  FC=
475    CPP=
476  LINK=  LINK=
477  DEFINES="-DWORDLENGTH=4"  # DEFINES="-DWORDLENGTH=4"
478    DEFINES=
479  PACKAGES=  PACKAGES=
480  ENABLE=  ENABLE=
481  DISABLE=  DISABLE=
# Line 312  KPPFILES= Line 496  KPPFILES=
496  NOOPTFILES=  NOOPTFILES=
497  NOOPTFLAGS=  NOOPTFLAGS=
498    
499    # DEFINES checked by test compilation
500    HAVE_SYSTEM=
501    HAVE_FDATE=
502    FC_NAMEMANGLE=
503    HAVE_CLOC=
504    HAVE_NETCDF=
505    
506  MODS=  MODS=
507  TOOLSDIR=  TOOLSDIR=
508  SOURCEDIRS=  SOURCEDIRS=
509  INCLUDEDIRS=  INCLUDEDIRS=
510  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
511    
512  PWD=`pwd`  PWD=`pwd`
513  MAKE=make  MAKE=make
# Line 349  TAMC_EXTRA= Line 540  TAMC_EXTRA=
540    
541    
542  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
543  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
544  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
545    
546  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
547  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
548  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
549  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
550  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
551    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"
552    
553  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
554  gm_s7="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
555  gm_s8="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"  gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
556  gm_s9="TAF_EXTRA TAMC_EXTRA"  gm_s12="TAF_EXTRA TAMC_EXTRA"
557    
558  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7 $gm_s8 $gm_s9"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
559    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
560    
561    cat <<EOF
562    
563    GENMAKE :
564    
565    A program for GENerating MAKEfiles for the MITgcm project.  For a
566    quick list of options, use "genmake -h" or for more detail see:
567    
568      http://mitgcm.org/devel_HOWTO/
569    
570    EOF
571    
 echo  
572  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
573  gm_local="genmake_local"  gm_local="genmake_local"
574  for i in . $MODS ; do  for i in . $MODS ; do
575      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
576          source $i/$gm_local          . $i/$gm_local
577          break          break
578      fi      fi
579  done  done
580  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
581  if test -e $gm_local ; then  if test -e $gm_local ; then
582      echo "using $gm_local"      echo "using $gm_local"
583      source $gm_local      . $gm_local
584      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
585      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
586  else  else
# Line 420  for ac_option ; do Line 622  for ac_option ; do
622          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
623              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
624                    
625          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
626              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
627          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
628              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 445  for ac_option ; do Line 647  for ac_option ; do
647          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
648              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
649                    
650          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
651              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
652          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
653              PLATFORM=$ac_optarg ;;              echo
654                usage
655                ;;
656                    
657          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
658              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 475  for ac_option ; do Line 679  for ac_option ; do
679          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
680              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
681    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
682  #           -cpp | --cpp)  #           -cpp | --cpp)
683  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
684  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 495  for ac_option ; do Line 694  for ac_option ; do
694          -noieee | --noieee)          -noieee | --noieee)
695              IEEE= ;;              IEEE= ;;
696                    
697          -mpi | --mpi)  #       -jam | --jam)
698              MPI=true ;;  #           JAM=1 ;;
699          -nompi | --nompi)  #       -nojam | --nojam)
700              MPI= ;;  #           JAM=0 ;;
           
         -jam | --jam)  
             JAM=1 ;;  
         -nojam | --nojam)  
             JAM=0 ;;  
701                    
702          -ds | --ds)          -ds | --ds)
703              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 582  fi Line 776  fi
776  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
777      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
778          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
779          source "$OPTFILE"          . "$OPTFILE"
780          RETVAL=$?          RETVAL=$?
781          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
782              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
# Line 609  fi Line 803  fi
803  if test "x${AD_OPTFILE}" != xNONE ; then  if test "x${AD_OPTFILE}" != xNONE ; then
804      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
805          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
806          source "$AD_OPTFILE"          . "$AD_OPTFILE"
807          RETVAL=$?          RETVAL=$?
808          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
809              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
# Line 625  if test "x${AD_OPTFILE}" != xNONE ; then Line 819  if test "x${AD_OPTFILE}" != xNONE ; then
819      fi      fi
820  fi  fi
821    
822  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
823  #  and abort!  #  either set defaults or complain and abort!
824  if test "x$FC" = x ; then  if test "x$FC" = x ; then
825      cat <<EOF 1>&2      cat <<EOF 1>&2
826    
# Line 640  fi Line 834  fi
834  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
835      LINK=$FC      LINK=$FC
836  fi  fi
837    if test "x$MAKE" = x ; then
838        MAKE="make"
839    fi
840  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
841      CPP="cpp"      CPP=cpp
842  fi  fi
843    #EH3 === UGLY ===
844    #  The following an ugly little hack to check for $CPP in /lib/ and it
845    #  should eventually be replaced with a more general function that
846    #  searches a combo of the user's path and a list of "usual suspects"
847    #  to find the correct location for binaries such as $CPP.
848    for i in " " "/lib/" ; do
849        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
850    done
851    #EH3 === UGLY ===
852  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
853  RETVAL=$?  RETVAL=$?
854  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 652  Error: C pre-processor "$CPP" failed the Line 858  Error: C pre-processor "$CPP" failed the
858    
859    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
860    2) the "./genmake_local" file    2) the "./genmake_local" file
861      3) with the CPP environment variable
862    
863  EOF  EOF
864      exit 1      exit 1
# Line 661  fi Line 868  fi
868  if test "x$MAKEDEPEND" = x ; then  if test "x$MAKEDEPEND" = x ; then
869      MAKEDEPEND=makedepend      MAKEDEPEND=makedepend
870  fi  fi
871    if test "x$LN" = x ; then
872        LN="ln -s"
873    fi
874    echo "test" > genmake_test_ln
875    $LN genmake_test_ln genmake_tlink
876    RETVAL=$?
877    if test "x$RETVAL" != x0 ; then
878        cat <<EOF 1>&2
879    
880    Error: The command "ln -s" failed -- please specify a working soft-link
881      command in the optfile.
882    
883    EOF
884        exit 1
885    fi
886    rm -f genmake_test_ln genmake_tlink
887    
888    
889    printf "\n===  Checking system libraries  ===\n"
890    echo -n "  Do we have the system() command using $FC...  "
891    cat > genmake_tcomp.f <<EOF
892          program hello
893          call system('echo hi')
894          end
895    EOF
896    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
897    RETVAL=$?
898    if test "x$RETVAL" = x0 ; then
899        HAVE_SYSTEM=t
900        DEFINES="$DEFINES -DHAVE_SYSTEM"
901        echo "yes"
902    else
903        HAVE_SYSTEM=
904        echo "no"
905    fi
906    rm -f genmake_tcomp*
907    
908    echo -n "  Do we have the fdate() command using $FC...  "
909    cat > genmake_tcomp.f <<EOF
910          program hello
911          CHARACTER(128) string
912          string = ' '
913          call fdate( string )
914          print *, string
915          end
916    EOF
917    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
918    RETVAL=$?
919    if test "x$RETVAL" = x0 ; then
920        HAVE_FDATE=t
921        DEFINES="$DEFINES -DHAVE_FDATE"
922        echo "yes"
923    else
924        HAVE_FDATE=
925        echo "no"
926    fi
927    rm -f genmake_tcomp*
928    
929    echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
930    check_HAVE_CLOC
931    if test "x$HAVE_CLOC" != x ; then
932        echo "yes"
933    else
934        echo "no"
935    fi
936    rm -f genmake_t*
937    
938    echo -n "  Can we create NetCDF-enabled binaries...  "
939    check_netcdf_libs
940    if test "x$HAVE_NETCDF" != x ; then
941        echo "yes"
942    else
943        echo "no"
944    fi
945    
946    
947  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
948  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
# Line 706  fi Line 988  fi
988  if test "x$S64" = x ; then  if test "x$S64" = x ; then
989      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
990  fi  fi
991    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
992    
993  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
994    
# Line 714  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 997  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
997  #  they appear as regular source code  #  they appear as regular source code
998  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
999      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1000      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1001      RETVAL=$?      RETVAL=$?
1002      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1003          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1004      else      else
1005          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1006          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1007          exit 1          exit 1
1008      fi      fi
1009  fi  fi
1010    
1011    #same for exch2
1012    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1013        echo "  Making source files in exch2 from  templates"
1014        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1015        RETVAL=$?
1016        if test "x${RETVAL}" = x0 ; then
1017            rm -f make_exch2.errors
1018        else
1019            echo "Error: problem encountered while building source files in exch2:"
1020            cat make_exch2.errors 1>&2
1021            exit 1
1022        fi
1023    fi
1024    
1025  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1026  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1027      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 751  if test ! "x${RETVAL}" = x0 ; then Line 1048  if test ! "x${RETVAL}" = x0 ; then
1048      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1049      exit 1      exit 1
1050  fi  fi
1051  source ./.pd_tmp  . ./.pd_tmp
1052  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1053    
1054  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1055  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1056  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1057  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1058  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1059      for i in "." $MODS ; do      for i in "." $MODS ; do
1060          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 770  if test "x${PDEFAULT}" = x ; then Line 1067  if test "x${PDEFAULT}" = x ; then
1067      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1068  fi  fi
1069  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1070      echo "default packages file disabled"      echo "    default packages file disabled"
1071  else  else
1072      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1073          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1074      else      else
1075          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1076          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1077          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1078          RETVAL=$?          RETVAL=$?
# Line 909  for i in $PACKAGES ; do Line 1205  for i in $PACKAGES ; do
1205      fi      fi
1206  done  done
1207    
1208  #  This is compatible with the old genmake.  The "DISABLE_*" flags  #  Build MNC templates and check for ability to build and use NetCDF
1209  #  need to be replaced by the "ALLOW_*" flags set below.  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1210  #  RETVAL=$?
1211  # echo -n "  Setting package-specific CPP flags:  "  if test "x$RETVAL" = x0 ; then
1212  # pkrm=( mom_fluxform mom_vecinv generic_advdiff )      ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1213  # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )      RETVAL=$?
1214  # echo -n "  "      if test "x${RETVAL}" = x0 ; then
1215  # i=0          rm -f make_mnc.errors
1216  # while test $i -lt "${#pkrm[@]}" ; do      else
1217  #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1          echo "Error: problem encountered while building source files in pkg/mnc:"
1218  #     RETVAL=$?          cat make_mnc.errors 1>&2
1219  #     if test "x$RETVAL" = x1 ; then          exit 1
1220  #       DEFINES="$DEFINES ${pkdef[$i]}"      fi
1221  #       echo -n " ${pkdef[$i]}"      if test "x$HAVE_NETCDF" != xt ; then
1222  #     fi          cat <<EOF
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
   
 # Create a list of #define and #undef to enable/disable packages  
 PACKAGES_DOT_H=PACKAGES_CONFIG.h  
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
1223    
1224  #ifndef PACKAGES_H  WARNING: the "mnc" package has been enabled but tests failed to
1225  #define PACKAGES_H    compile and/or execute NetCDF applications.  Please check that:
1226    
1227  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1228      2) the LIBS variable (within the 'optfile") specifies the correct
1229           NetCDF library to link against.
1230      
1231  EOF  EOF
1232        fi
1233    fi
1234    
1235    # Create a list of #define and #undef to enable/disable packages
1236    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1237  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1238  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1239  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1240  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1241  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1242  all_pack=  all_pack=
1243    DISABLED_PACKAGES=
1244  for n in $names ; do  for n in $names ; do
1245      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1246          has_pack="f"          has_pack="f"
# Line 959  for n in $names ; do Line 1252  for n in $names ; do
1252          done          done
1253          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1254              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1255              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
 #           DEFINES="$DEFINES -U$undef"  
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1256          fi          fi
1257      fi      fi
1258  done  done
1259  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1260  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1261      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1262      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1263  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1264    
1265  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1266      case $i in      case $i in
1267          aim_v23)          aim_v23)
1268              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1269              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1270              ;;              ;;
1271      esac      esac
1272  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1273    
1274  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1275    
1276  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1277  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1278  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1279      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1280  fi  fi
1281  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1282      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1283      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1284          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1285          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1286          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1287      else              exit 1
1288          SOURCEDIRS="$SOURCEDIRS $adr"          else
1289      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1290      adr="$ROOTDIR/$d/inc"          fi
1291      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1292          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1293          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1294          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1295      else              exit 1
1296          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1297      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1298  done          fi
1299        done
1300    fi
1301    
1302  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1303  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1304  CPP_OPTIONS=  CPP_OPTIONS=
1305    CPP_EEOPTIONS=
1306  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1307    names=`ls -1 "$ROOTDIR/pkg"`
1308  for i in $spaths ; do  for i in $spaths ; do
1309      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1310      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1311          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1312          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1313          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1314            for n in $names ; do
1315                test_for_package_in_cpp_options $CPP_OPTIONS $n
1316            done
1317        fi
1318        try="$i/CPP_EEOPTIONS.h"
1319        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1320            echo "    found CPP_EEOPTIONS=\"$try\""
1321            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1322    #**** not yet enabled ****
1323    #        test_for_mpi_in_cpp_eeoptions $try
1324    #**** not yet enabled ****
1325            CPP_EEOPTIONS="$try"
1326      fi      fi
1327  done  done
1328  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1329      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1330      exit 1      exit 1
1331  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1332    
1333  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1334  #  compiler.  #  compiler.
# Line 1078  for i in $SOURCEDIRS ; do Line 1343  for i in $SOURCEDIRS ; do
1343      done      done
1344  done  done
1345    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1346    
1347  echo  echo
1348  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1119  for d in $alldirs ; do Line 1373  for d in $alldirs ; do
1373      for sf in $sfiles ; do      for sf in $sfiles ; do
1374          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1375              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1376                    case $d/$sf in
1377                      ./$PACKAGES_DOT_H)
1378                            ;;
1379                      ./AD_CONFIG.h)
1380                            ;;
1381                      ./FC_NAMEMANGLE.h)
1382                            ;;
1383                      *)
1384                            touch .links.tmp/$sf
1385                            deplist="$deplist $sf"
1386                            ;;
1387                    esac
1388                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1389                  case $extn in                  case $extn in
1390                      F)                      F)
1391                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
# Line 1179  EXE_FTL=$EXECUTABLE"_ftl" Line 1443  EXE_FTL=$EXECUTABLE"_ftl"
1443  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1444    
1445  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1446    #
1447    # OPTFILE="$OPTFILE"
1448  #  #
1449  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1450  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1212  EXE_AD      = ${EXE_AD} Line 1478  EXE_AD      = ${EXE_AD}
1478  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1479  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1480    
1481    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1482    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1483    
1484    # These files are created by Makefile
1485    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1486    
1487  EOF  EOF
1488    
1489  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1276  cat >>$MAKEFILE <<EOF Line 1548  cat >>$MAKEFILE <<EOF
1548  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1549    
1550  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1551  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1552            @echo Creating \$@ ...
1553          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1554  depend:  depend:
1555          @make links          @make links
1556          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1557          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1558    
1559  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1560    
1561  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1562    
# Line 1292  output.txt: \$(EXECUTABLE) Line 1565  output.txt: \$(EXECUTABLE)
1565          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1566    
1567  clean:  clean:
1568          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1569  Clean:  Clean:
1570          @make clean          @make clean
1571          @make cleanlinks          @make cleanlinks
1572          -rm -f Makefile.bak genmake_state genmake_*optfile make.log          -rm -f \$(SPECIAL_FILES)
1573            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1574  CLEAN:  CLEAN:
1575          @make Clean          @make Clean
1576          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1307  CLEAN: Line 1580  CLEAN:
1580    
1581  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1582  makefile:  makefile:
1583          ${0} $@          $THIS_SCRIPT $@
1584  cleanlinks:  cleanlinks:
1585          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1586    
1587    # Special targets ($SPECIAL_FILES) which are create by make
1588    ${PACKAGES_DOT_H}:
1589            @echo Creating \$@ ...
1590            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1591    AD_CONFIG.h:
1592            @echo Creating \$@ ...
1593            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1594    FC_NAMEMANGLE.h:
1595            @echo Creating \$@ ...
1596            echo "$FC_NAMEMANGLE" > \$@
1597    
1598  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1599  .F.f:  .F.f:
1600          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 1369  adall: ad_taf Line 1653  adall: ad_taf
1653  adtaf: ad_taf_output.f  adtaf: ad_taf_output.f
1654  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1655    
1656  ad_input_code.f: \$(SRCFILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1657            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1658          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1659            -rm -f ad_config.template
1660          @make \$(F77FILES)          @make \$(F77FILES)
1661          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1662          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1663    
1664  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1665          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1666          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1667    
1668    adtafonly:
1669            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1670            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1671    
1672  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1673          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1674    
1675  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1676          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1677          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1678    
1679  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1680          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1395  ftlall: ftl_taf Line 1685  ftlall: ftl_taf
1685  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.f
1686  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1687    
1688  ftl_input_code.f: \$(SRCFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1689            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1690          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1691            -rm -f ftl_config.template
1692          @make \$(F77FILES)          @make \$(F77FILES)
1693          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1694          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1695    
1696  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
1697          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1698          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1699    
1700    ftltafonly:
1701            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1702            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1703    
1704  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1705          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1706    
1707  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1708          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1709          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1710    
1711  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1712          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1713    
1714    
1715  # ... SVD ...  # ... SVD ...
1716  svd: svd_taf  svdtaf: ad_taf_output.f ftl_taf_output.f
1717  svd_taf_f: svd_taf_output.f  svdall: svd_taf
   
 svd_input_code.f: \$(SRCFILES)  
         cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h  
         @make \$(F77FILES)  
         @make \$(AD_FLOW_FILES)  
         cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f  
   
 svd_taf_output.f: svd_input_code.f  
         \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f  
         cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
1718    
1719  svd_taf: svd_taf_output.o \$(OBJFILES)  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1720          \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
1721    
1722    
1723  #=========================================  #=========================================
# Line 1472  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1758  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1758    
1759  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1760    
1761  #  Write the "template" files for the adjoint builds  # Create special header files
1762  cat >AD_CONFIG.template <<EOF  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1763  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
1764  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1765  C    unless you are CERTAIN that you know what you are doing.  else
1766        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1767  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
1768  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
1769  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
1770  EOF      else
1771  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1772  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1773  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
1774  C    unless you are CERTAIN that you know what you are doing.  fi
1775    if test ! -f AD_CONFIG.h ; then
1776  #define ALLOW_ADJOINT_RUN      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1777  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
1778    
1779    
1780  #  Write the "state" for future records  #  Write the "state" for future records

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.64

  ViewVC Help
Powered by ViewVC 1.1.22